header {* Very Simple Propositional Logic I *}
theory VSPL0
imports Pure
begin

text{* 
  Hier wird der Typ o deklariert; fr die einfache Aussagenlogik 
  gibt es nur einen einzigen Typ. *} 
typedecl o

text{* Dieser Teil ist rein technischer Natur. *}
judgment
  Trueprop  :: "o => prop"                  ("(_)" 5)

text{* 
  Deklaration der Konstanten False, And, Implies.
  (Der Teil in Klammern sorgt fr schicke Syntax, e.g. A & B).
  *}

axiomatization
      False   :: o
  and And     :: "[o, o] => o"                (infixr "&" 35)
  and Implies :: "[o, o] => o"                (infixr "-->" 25)

text{* 
  Die sieben Grundregeln der einfachen Aussagenlogik.
  *}

axiomatization where
      conjI:  "[| P;  Q |] ==> P&Q"
  and conjE1: "[| P&Q |] ==> P"
  and conjE2: "[| P&Q |] ==> Q"

  and impI:   "(P ==> Q) ==> P -->Q"
  and impE:   "[| P-->Q ; P|] ==> Q"

  and False:  "[| False |] ==> P"
  and Raa:    "[| P--> False ==> False |] ==> P"


text{*
  Zwei einfache Eigenschaften, die wir spter bentigen.
  *}

lemma doubleneg: "((A --> False)--> False)--> A"
  apply (rule impI)
  apply (rule Raa)
  apply (rule impE [where P="A--> False"])
  apply (assumption)
  apply (assumption)
  done

lemma doubleneg2: "A--> ((A--> False)--> False)"
  apply (rule impI)
  apply (rule impI)
  apply (rule impE [where P="A"])
  apply (assumption)+ 
  done

end

